Index: code/trunk/src/audio/AudioIncludes.h
===================================================================
--- code/trunk/src/audio/AudioIncludes.h	(revision 1740)
+++ code/trunk/src/audio/AudioIncludes.h	(revision 1747)
@@ -47,3 +47,3 @@
 #include <vorbis/vorbisfile.h>
 
-#include "core/Error.h"
+#include "util/Error.h"
Index: code/trunk/src/audio/AudioManager.cc
===================================================================
--- code/trunk/src/audio/AudioManager.cc	(revision 1740)
+++ code/trunk/src/audio/AudioManager.cc	(revision 1747)
@@ -36,6 +36,6 @@
 #include "AudioSource.h"
 #include "AudioStream.h"
-#include "core/Error.h"
-#include "core/Debug.h"
+#include "util/Error.h"
+#include "util/Debug.h"
 
 namespace audio
Index: code/trunk/src/audio/AudioManager.h
===================================================================
--- code/trunk/src/audio/AudioManager.h	(revision 1740)
+++ code/trunk/src/audio/AudioManager.h	(revision 1747)
@@ -58,7 +58,4 @@
 		void setOri(std::vector<float> at, std::vector<float> up);
 
-		// Parses given xml string
-		void loadParams();
-
 		// Update
 		void tick(float dt);
Index: code/trunk/src/audio/AudioStream.cc
===================================================================
--- code/trunk/src/audio/AudioStream.cc	(revision 1740)
+++ code/trunk/src/audio/AudioStream.cc	(revision 1747)
@@ -28,6 +28,6 @@
 #include "AudioStream.h"
 
-#include "core/Debug.h"
-#include "core/Error.h"
+#include "util/Debug.h"
+#include "util/Error.h"
 
 namespace audio
Index: code/trunk/src/core/BaseObject.h
===================================================================
--- code/trunk/src/core/BaseObject.h	(revision 1740)
+++ code/trunk/src/core/BaseObject.h	(revision 1747)
@@ -39,6 +39,7 @@
 #include "CorePrereqs.h"
 
+#include "Super.h"
+#include "OrxonoxClass.h"
 #include "util/XMLIncludes.h"
-#include "OrxonoxClass.h"
 
 namespace orxonox
@@ -101,4 +102,8 @@
             Namespace* namespace_;
     };
+
+    SUPER_FUNCTION(0, BaseObject, XMLPort, false);
+    SUPER_FUNCTION(2, BaseObject, changedActivity, false);
+    SUPER_FUNCTION(3, BaseObject, changedVisibility, false);
 }
 
Index: code/trunk/src/core/CMakeLists.txt
===================================================================
--- code/trunk/src/core/CMakeLists.txt	(revision 1740)
+++ code/trunk/src/core/CMakeLists.txt	(revision 1747)
@@ -3,11 +3,8 @@
   ConfigValueContainer.cc
   Core.cc
-  Error.cc
   Language.cc
+  ObjectListBase.cc
   OrxonoxClass.cc
-  OutputBuffer.cc
-  OutputHandler.cc
   Script.cc
-  SignalHandler.cc
 
   # command
Index: code/trunk/src/core/ClassFactory.h
===================================================================
--- code/trunk/src/core/ClassFactory.h	(revision 1740)
+++ code/trunk/src/core/ClassFactory.h	(revision 1747)
@@ -43,5 +43,5 @@
 #include "Factory.h"
 #include "Identifier.h"
-#include "Debug.h"
+#include "util/Debug.h"
 
 namespace orxonox
@@ -74,5 +74,5 @@
     {
         COUT(4) << "*** ClassFactory: Create entry for " << name << " in Factory." << std::endl;
-        ClassIdentifier<T>::getIdentifier()->addFactory(new ClassFactory<T>);
+        ClassIdentifier<T>::getIdentifier(name)->addFactory(new ClassFactory<T>);
         Factory::add(name, ClassIdentifier<T>::getIdentifier());
 
Index: code/trunk/src/core/ClassTreeMask.h
===================================================================
--- code/trunk/src/core/ClassTreeMask.h	(revision 1740)
+++ code/trunk/src/core/ClassTreeMask.h	(revision 1747)
@@ -78,7 +78,7 @@
 namespace orxonox
 {
-    // ###############################
-    // ###    ClassTreeMaskNode    ###
-    // ###############################
+    // ###################################
+    // ###      ClassTreeMaskNode      ###
+    // ###################################
     //! The ClassTreeMaskNode is a node in the internal tree of the ClassTreeMask, containing the rules of the mask.
     /**
@@ -116,7 +116,7 @@
 
 
-    // ###############################
-    // ###  ClassTreeMaskIterator  ###
-    // ###############################
+    // ###################################
+    // ###    ClassTreeMaskIterator    ###
+    // ###################################
     //! The ClassTreeMaskIterator moves through all ClassTreeMaskNodes of the internal tree of a ClassTreeMask, containing the rules.
     /**
@@ -146,7 +146,7 @@
 
 
-    // ###############################
-    // ###      ClassTreeMask      ###
-    // ###############################
+    // ###################################
+    // ###        ClassTreeMask        ###
+    // ###################################
     //! The ClassTreeMask is a set of rules, containing the information for each class whether it's included or not.
     /**
@@ -214,4 +214,16 @@
             ClassTreeMaskNode* root_;   //!< The root-node of the internal rule-tree, usually BaseObject
     };
+
+
+    // ###################################
+    // ### ClassTreeMaskObjectIterator ###
+    // ###################################
+    //! ...
+    /**
+        ...
+    */
+    class _CoreExport ClassTreeMaskObjectIterator
+    {
+    };
 }
 
Index: code/trunk/src/core/CommandEvaluation.cc
===================================================================
--- code/trunk/src/core/CommandEvaluation.cc	(revision 1740)
+++ code/trunk/src/core/CommandEvaluation.cc	(revision 1747)
@@ -30,5 +30,5 @@
 #include "ConsoleCommand.h"
 #include "Identifier.h"
-#include "Debug.h"
+#include "util/Debug.h"
 #include "util/String.h"
 
@@ -218,5 +218,5 @@
     }
 
-    void CommandEvaluation::setEvaluatedParameter(unsigned int index, MultiTypeMath param)
+    void CommandEvaluation::setEvaluatedParameter(unsigned int index, MultiType param)
     {
         if (index >= 0 && index < MAX_FUNCTOR_ARGUMENTS)
@@ -224,5 +224,5 @@
     }
 
-    MultiTypeMath CommandEvaluation::getEvaluatedParameter(unsigned int index) const
+    MultiType CommandEvaluation::getEvaluatedParameter(unsigned int index) const
     {
         if (index >= 0 && index < MAX_FUNCTOR_ARGUMENTS)
@@ -240,10 +240,10 @@
     }
 
-    MultiTypeMath CommandEvaluation::getReturnvalue() const
+    MultiType CommandEvaluation::getReturnvalue() const
     {
         if (this->function_)
             return this->function_->getReturnvalue();
 
-        return MultiTypeMath();
+        return MultiType();
     }
 
@@ -304,5 +304,5 @@
 
             if (command->defaultValueSet(i))
-                output += "=" + command->getDefaultValue(i).toString() + "]";
+                output += "=" + command->getDefaultValue(i).getString() + "]";
             else
                 output += "}";
Index: code/trunk/src/core/CommandEvaluation.h
===================================================================
--- code/trunk/src/core/CommandEvaluation.h	(revision 1740)
+++ code/trunk/src/core/CommandEvaluation.h	(revision 1747)
@@ -37,5 +37,5 @@
 #include "ArgumentCompletionListElement.h"
 #include "util/SubString.h"
-#include "util/MultiTypeMath.h"
+#include "util/MultiType.h"
 
 namespace orxonox
@@ -81,9 +81,9 @@
                 { return (this->additionalParameter_ != "") ? (" " + this->additionalParameter_) : ""; }
 
-            void setEvaluatedParameter(unsigned int index, MultiTypeMath param);
-            MultiTypeMath getEvaluatedParameter(unsigned int index) const;
+            void setEvaluatedParameter(unsigned int index, MultiType param);
+            MultiType getEvaluatedParameter(unsigned int index) const;
 
             bool hasReturnvalue() const;
-            MultiTypeMath getReturnvalue() const;
+            MultiType getReturnvalue() const;
 
         private:
@@ -115,5 +115,5 @@
 
             bool bEvaluatedParams_;
-            MultiTypeMath param_[5];
+            MultiType param_[5];
     };
 }
Index: code/trunk/src/core/CommandExecutor.cc
===================================================================
--- code/trunk/src/core/CommandExecutor.cc	(revision 1740)
+++ code/trunk/src/core/CommandExecutor.cc	(revision 1747)
@@ -31,7 +31,7 @@
 #include "util/String.h"
 #include "util/Convert.h"
+#include "util/Debug.h"
 #include "Identifier.h"
 #include "Language.h"
-#include "Debug.h"
 #include "TclBind.h"
 
Index: code/trunk/src/core/ConfigFileManager.cc
===================================================================
--- code/trunk/src/core/ConfigFileManager.cc	(revision 1740)
+++ code/trunk/src/core/ConfigFileManager.cc	(revision 1747)
@@ -38,10 +38,10 @@
 namespace orxonox
 {
-    SetConsoleCommandShortcutExtern(config).setArgumentCompleter(0, autocompletion::configvalueclasses()).setArgumentCompleter(1, autocompletion::configvalues()).setArgumentCompleter(2, autocompletion::configvalue());
-    SetConsoleCommandShortcutExtern(tconfig).setArgumentCompleter(0, autocompletion::configvalueclasses()).setArgumentCompleter(1, autocompletion::configvalues()).setArgumentCompleter(2, autocompletion::configvalue());
+    SetConsoleCommandShortcutExtern(config).argumentCompleter(0, autocompletion::configvalueclasses()).argumentCompleter(1, autocompletion::configvalues()).argumentCompleter(2, autocompletion::configvalue());
+    SetConsoleCommandShortcutExtern(tconfig).argumentCompleter(0, autocompletion::configvalueclasses()).argumentCompleter(1, autocompletion::configvalues()).argumentCompleter(2, autocompletion::configvalue());
     SetConsoleCommandShortcutExtern(reloadConfig);
     SetConsoleCommandShortcutExtern(cleanConfig);
-    SetConsoleCommandShortcutExtern(loadSettings).setArgumentCompleter(0, autocompletion::files());
-    SetConsoleCommandShortcutExtern(loadKeybindings).setArgumentCompleter(0, autocompletion::files());
+    SetConsoleCommandShortcutExtern(loadSettings).argumentCompleter(0, autocompletion::files());
+    SetConsoleCommandShortcutExtern(loadKeybindings).argumentCompleter(0, autocompletion::files());
 
     bool config(const std::string& classname, const std::string& varname, const std::string& value)
@@ -71,20 +71,20 @@
     void reloadConfig()
     {
-        ConfigFileManager::getSingleton()->load();
+        ConfigFileManager::getInstance()->load();
     }
 
     void cleanConfig()
     {
-        ConfigFileManager::getSingleton()->clean(false);
+        ConfigFileManager::getInstance()->clean(false);
     }
 
     void loadSettings(const std::string& filename)
     {
-        ConfigFileManager::getSingleton()->setFile(CFT_Settings, filename, false);
+        ConfigFileManager::getInstance()->setFile(CFT_Settings, filename, false);
     }
 
     void loadKeybindings(const std::string& filename)
     {
-        ConfigFileManager::getSingleton()->setFile(CFT_Keybindings, filename);
+        ConfigFileManager::getInstance()->setFile(CFT_Keybindings, filename);
     }
 
@@ -327,5 +327,5 @@
         file.close();
 
-        COUT(3) << "Loaded config file \"" << this->filename_ << "\"." << std::endl;
+        COUT(0) << "Loaded config file \"" << this->filename_ << "\"." << std::endl;
 
         // Save the file in case something changed (like stripped whitespaces)
@@ -459,5 +459,5 @@
     }
 
-    ConfigFileManager* ConfigFileManager::getSingleton()
+    ConfigFileManager* ConfigFileManager::getInstance()
     {
         static ConfigFileManager instance;
Index: code/trunk/src/core/ConfigFileManager.h
===================================================================
--- code/trunk/src/core/ConfigFileManager.h	(revision 1740)
+++ code/trunk/src/core/ConfigFileManager.h	(revision 1747)
@@ -258,5 +258,5 @@
     {
         public:
-            static ConfigFileManager* getSingleton();
+            static ConfigFileManager* getInstance();
 
             void setFile(ConfigFileType type, const std::string& filename, bool bCreateIfNotExisting = true);
Index: code/trunk/src/core/ConfigValueContainer.cc
===================================================================
--- code/trunk/src/core/ConfigValueContainer.cc	(revision 1740)
+++ code/trunk/src/core/ConfigValueContainer.cc	(revision 1747)
@@ -47,11 +47,7 @@
 {
     /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param type The type of the corresponding config-file
-        @param identifier The identifier of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(ConfigFileType type, Identifier* identifier, const std::string& varname, const MultiTypeMath& defvalue)
+        @brief Initializes the ConfigValueContainer with defaultvalues.
+    */
+    void ConfigValueContainer::init(ConfigFileType type, Identifier* identifier, const std::string& varname)
     {
         this->type_ = type;
@@ -59,43 +55,45 @@
         this->sectionname_ = identifier->getName();
         this->varname_ = varname;
-
+        this->callback_ = 0;
+        this->bContainerIsNew_ = true;
+        this->bDoInitialCallback_ = false;
+        this->bAddedDescription_ = false;
+    }
+
+    /**
+        @brief Does some special initialization for single config-values.
+    */
+    void ConfigValueContainer::initValue(const MultiType& defvalue)
+    {
         this->value_ = defvalue;
-        this->bAddedDescription_ = false;
         this->bIsVector_ = false;
 
-        this->defvalueString_ = defvalue.toString();
+        this->defvalueString_ = this->value_.getString();
         this->update();
     }
 
     /**
-        @brief Constructor: Converts the default-value to a string, checks the config-file for a changed value, sets the intern value variable.
-        @param type The type of the corresponding config-file
-        @param identifier The identifier of the class the variable belongs to
-        @param varname The name of the variable
-        @param defvalue The default-value
-    */
-    ConfigValueContainer::ConfigValueContainer(ConfigFileType type, Identifier* identifier, const std::string& varname, const std::vector<MultiTypeMath>& defvalue)
-    {
-        this->type_ = type;
-        this->identifier_ = identifier;
-        this->sectionname_ = identifier->getName();
-        this->varname_ = varname;
-
-        this->valueVector_ = defvalue;
-        this->bAddedDescription_ = false;
+        @brief Does some special initialization for vector config-values.
+    */
+    void ConfigValueContainer::initVector()
+    {
         this->bIsVector_ = true;
 
-        if (defvalue.size() > 0)
-        {
-                this->value_ = defvalue[0];
-
-            for (unsigned int i = 0; i < defvalue.size(); i++)
-            {
-                ConfigFileManager::getSingleton()->getValue(this->type_, this->sectionname_, this->varname_, i, defvalue[i].toString(), this->value_.isA(MT_string));
-                this->defvalueStringVector_.push_back(defvalue[i].toString());
-            }
-
-            this->update();
-        }
+        for (unsigned int i = 0; i < this->valueVector_.size(); i++)
+        {
+            ConfigFileManager::getInstance()->getValue(this->type_, this->sectionname_, this->varname_, i, this->valueVector_[i], this->value_.isType(MT_string));
+            this->defvalueStringVector_.push_back(this->valueVector_[i]);
+        }
+
+        this->update();
+    }
+
+    /**
+        @brief Destructor: Deletes the callback object if necessary.
+    */
+    ConfigValueContainer::~ConfigValueContainer()
+    {
+        if (this->callback_)
+            delete this->callback_;
     }
 
@@ -105,9 +103,9 @@
         @return True if the new value was successfully assigned
     */
-    bool ConfigValueContainer::set(const MultiTypeMath& input)
-    {
-        if (this->bIsVector_)
-        {
-            return this->callFunctionWithIndex(&ConfigValueContainer::set, input.toString());
+    bool ConfigValueContainer::set(const MultiType& input)
+    {
+        if (this->bIsVector_)
+        {
+            return this->callFunctionWithIndex(&ConfigValueContainer::set, input);
         }
         else
@@ -115,5 +113,5 @@
             if (this->tset(input))
             {
-                ConfigFileManager::getSingleton()->setValue(this->type_, this->sectionname_, this->varname_, input.toString(), this->value_.isA(MT_string));
+                ConfigFileManager::getInstance()->setValue(this->type_, this->sectionname_, this->varname_, input, this->value_.isType(MT_string));
                 return true;
             }
@@ -128,5 +126,5 @@
         @return True if the new value was successfully assigned
     */
-    bool ConfigValueContainer::set(unsigned int index, const MultiTypeMath& input)
+    bool ConfigValueContainer::set(unsigned int index, const MultiType& input)
     {
         if (this->bIsVector_)
@@ -134,5 +132,5 @@
             if (this->tset(index, input))
             {
-                ConfigFileManager::getSingleton()->setValue(this->type_, this->sectionname_, this->varname_, index, input.toString(), this->value_.isA(MT_string));
+                ConfigFileManager::getInstance()->setValue(this->type_, this->sectionname_, this->varname_, index, input, this->value_.isType(MT_string));
                 return true;
             }
@@ -150,23 +148,20 @@
         @return True if the new value was successfully assigned
     */
-    bool ConfigValueContainer::tset(const MultiTypeMath& input)
-    {
-        if (this->bIsVector_)
-        {
-            return this->callFunctionWithIndex(&ConfigValueContainer::tset, input.toString());
-        }
-        else
-        {
-            MultiTypeMath temp = this->value_;
-            if (temp.assimilate(input))
-            {
-                this->value_ = temp;
-                if (this->identifier_)
-                    this->identifier_->updateConfigValues();
-
-                return true;
-            }
-        }
-        return false;
+    bool ConfigValueContainer::tset(const MultiType& input)
+    {
+        if (this->bIsVector_)
+        {
+            return this->callFunctionWithIndex(&ConfigValueContainer::tset, input);
+            return false;
+        }
+        else
+        {
+            this->value_ = input;
+
+            if (this->identifier_)
+                this->identifier_->updateConfigValues();
+
+            return true;
+        }
     }
 
@@ -177,5 +172,5 @@
         @return True if the new value was successfully assigned
     */
-    bool ConfigValueContainer::tset(unsigned int index, const MultiTypeMath& input)
+    bool ConfigValueContainer::tset(unsigned int index, const MultiType& input)
     {
         if (this->bIsVector_)
@@ -191,24 +186,20 @@
                 for (unsigned int i = this->valueVector_.size(); i <= index; i++)
                 {
-                    this->valueVector_.push_back(MultiTypeMath());
+                    this->valueVector_.push_back(MultiType());
                 }
             }
 
-            MultiTypeMath temp = this->value_;
-            if (temp.assimilate(input))
-            {
-                this->valueVector_[index] = temp;
-
-                if (this->identifier_)
-                    this->identifier_->updateConfigValues();
-
-                return true;
-            }
+            this->valueVector_[index] = input;
+
+            if (this->identifier_)
+                this->identifier_->updateConfigValues();
+
+            return true;
         }
         else
         {
             COUT(1) << "Error: Config-value '" << this->varname_ << "' in " << this->sectionname_ << " is not a vector." << std::endl;
-        }
-        return false;
+            return false;
+        }
     }
 
@@ -218,5 +209,5 @@
         @return True if the new entry was successfully added
     */
-    bool ConfigValueContainer::add(const MultiTypeMath& input)
+    bool ConfigValueContainer::add(const MultiType& input)
     {
         if (this->bIsVector_)
@@ -241,6 +232,6 @@
                 this->valueVector_.erase(this->valueVector_.begin() + index);
                 for (unsigned int i = index; i < this->valueVector_.size(); i++)
-                    ConfigFileManager::getSingleton()->setValue(this->type_, this->sectionname_, this->varname_, i, this->valueVector_[i], this->value_.isA(MT_string));
-                ConfigFileManager::getSingleton()->deleteVectorEntries(this->type_, this->sectionname_, this->varname_, this->valueVector_.size());
+                    ConfigFileManager::getInstance()->setValue(this->type_, this->sectionname_, this->varname_, i, this->valueVector_[i], this->value_.isType(MT_string));
+                ConfigFileManager::getInstance()->deleteVectorEntries(this->type_, this->sectionname_, this->varname_, this->valueVector_.size());
 
                 return true;
@@ -266,5 +257,5 @@
                 if (!this->set(i, this->defvalueStringVector_[i]))
                     success = false;
-            ConfigFileManager::getSingleton()->deleteVectorEntries(this->type_, this->sectionname_, this->varname_, this->defvalueStringVector_.size());
+            ConfigFileManager::getInstance()->deleteVectorEntries(this->type_, this->sectionname_, this->varname_, this->defvalueStringVector_.size());
             return success;
         }
@@ -277,17 +268,17 @@
     {
         if (!this->bIsVector_)
-            this->value_.fromString(ConfigFileManager::getSingleton()->getValue(this->type_, this->sectionname_, this->varname_, this->defvalueString_, this->value_.isA(MT_string)));
+            this->value_ = ConfigFileManager::getInstance()->getValue(this->type_, this->sectionname_, this->varname_, this->defvalueString_, this->value_.isType(MT_string));
         else
         {
             this->valueVector_.clear();
-            for (unsigned int i = 0; i < ConfigFileManager::getSingleton()->getVectorSize(this->type_, this->sectionname_, this->varname_); i++)
+            for (unsigned int i = 0; i < ConfigFileManager::getInstance()->getVectorSize(this->type_, this->sectionname_, this->varname_); i++)
             {
                 if (i < this->defvalueStringVector_.size())
                 {
-                    this->value_.fromString(ConfigFileManager::getSingleton()->getValue(this->type_, this->sectionname_, this->varname_, i, this->defvalueStringVector_[i], this->value_.isA(MT_string)));
+                    this->value_ = ConfigFileManager::getInstance()->getValue(this->type_, this->sectionname_, this->varname_, i, this->defvalueStringVector_[i], this->value_.isType(MT_string));
                 }
                 else
                 {
-                    this->value_.fromString(ConfigFileManager::getSingleton()->getValue(this->type_, this->sectionname_, this->varname_, i, MultiTypeMath(), this->value_.isA(MT_string)));
+                    this->value_ = ConfigFileManager::getInstance()->getValue(this->type_, this->sectionname_, this->varname_, i, MultiType(), this->value_.isType(MT_string));
                 }
 
@@ -303,5 +294,5 @@
         @return The returnvalue of the functioncall
     */
-    bool ConfigValueContainer::callFunctionWithIndex(bool (ConfigValueContainer::* function) (unsigned int, const MultiTypeMath&), const std::string& input)
+    bool ConfigValueContainer::callFunctionWithIndex(bool (ConfigValueContainer::* function) (unsigned int, const MultiType&), const std::string& input)
     {
         SubString token(input, " ", SubString::WhiteSpaces, true, '\\', false, '"', false, '(', ')', false, '\0');
@@ -335,5 +326,5 @@
         @param description The description
     */
-    void ConfigValueContainer::description(const std::string& description)
+    ConfigValueContainer& ConfigValueContainer::description(const std::string& description)
     {
         if (!this->bAddedDescription_)
@@ -343,4 +334,5 @@
             this->bAddedDescription_ = true;
         }
+        return (*this);
     }
 
